<script setup lang="ts">
  import {
    Listbox,
    ListboxButton,
    ListboxOptions,
    ListboxOption,
    ListboxLabel,
  } from '@headlessui/vue';
  import { useScrollLock } from '@vueuse/core';
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';

  const stylingMapping = {
    button: {
      default: `cursor-pointer focus:(ring-primary outline-2 ring-2) relative w-full cursor-default rounded-md bg-white text-(left sm) shadow ring-(1 inset border)`,
      small: 'py-0.5 pl-2 pr-8',
      medium: 'py-2 pl-3 pr-9',
      large: 'py-2.5 pl-3 pr-10',
      error: '!ring-crimson-500',
    },
    arrow: {
      default: `pointer-events-none absolute inset-y-0 right-0 flex items-center`,
      small: 'pr-2',
      medium: 'pr-3',
      large: 'pr-3',
    },
  };
  const { t } = useI18n();

  const props = withDefaults(
    defineProps<{
      options: any[];
      modelValue?: any[] | any;
      label?: string;
      multiple?: boolean;
      placeholder?: string;
      errors?: any[];
      keyField?: string;
      size?: 'small' | 'medium' | 'large';
      labelField?: string;
      returnObjectValue?: boolean;
    }>(),
    {
      multiple: false,
      options: () => [],
      modelValue: null,
      placeholder: '',
      keyField: 'id',
      size: 'medium',
      labelField: 'name',
      label: undefined,
      returnObjectValue: false,
      errors: () => [],
    },
  );

  const selectedValue = ref();

  const emit = defineEmits(['update:modelValue']);

  const btnRef = ref<any>();
  const $el = computed(() => btnRef.value?.$el);
  const { getPanelStyling } = usePopover($el);
  const $body = ref<HTMLElement | null>();
  const isLocked = useScrollLock($body);

  syncRefs(toRef(props, 'modelValue'), selectedValue);

  onMounted(() => {
    $body.value = document.body;
  });

  const handleOpen = () => {
    isLocked.value = true;
  };

  const handleClose = () => {
    isLocked.value = false;
  };

  const handleItemClick = (e: Event) => {
    e.stopPropagation();
    emit('update:modelValue', selectedValue.value);
    if (!props.multiple) {
      isLocked.value = false;
    }
  };

  const labelName = computed(() => {
    if (Array.isArray(selectedValue.value) && selectedValue.value.length) {
      return selectedValue.value
        .map((v) => {
          if (props.returnObjectValue) {
            return getTranslatedProperty(v, props.labelField);
          } else {
            const item = props.options.find((x: any) => x[props.keyField as any] === v);
            return getTranslatedProperty(item, props.labelField);
          }
        })
        .join(', ');
    } else if (!Array.isArray(selectedValue.value) && selectedValue.value) {
      if (props.returnObjectValue) {
        return getTranslatedProperty(selectedValue.value, props.labelField);
      } else {
        const item = props.options.find(
          (x: any) => x[props.keyField as any] === selectedValue.value,
        );
        return getTranslatedProperty(item, props.labelField);
      }
    }
    return props.placeholder || t('form.selectPlaceholder');
  });
</script>

<template>
  <div>
    <Listbox v-slot="{ open }" v-model="selectedValue" as="div" :multiple="multiple">
      <slot name="label">
        <ListboxLabel v-if="label" class="text-information-dark mb-1.5 block text-sm/4 font-medium">
          {{ label }}
        </ListboxLabel>
      </slot>
      <div class="relative">
        <ListboxButton
          ref="btnRef"
          v-slot="{ value }"
          :class="[
            stylingMapping.button.default,
            stylingMapping.button[props.size],
            errors?.length && stylingMapping.button.error,
          ]"
          @click="handleOpen"
        >
          <span
            :class="[
              (Array.isArray(value) && value.length) || (!Array.isArray(value) && value)
                ? 'text-information font-medium'
                : 'text-information-subdued font-normal',
              'block truncate first-letter:capitalize',
            ]"
          >
            <slot name="button-text" v-bind="{ value, labelName }">
              {{ labelName }}
            </slot>
          </span>
          <span :class="[stylingMapping.arrow.default, stylingMapping.arrow[props.size]]">
            <slot name="icon">
              <span
                class="i-sw-regular:chevron-down-xs text(darkgray-600 [1.5rem]) group-focus:rotate-180"
              />
            </slot>
          </span>
        </ListboxButton>
        <Transition
          leave-active-class="transition ease-in duration-100"
          leave-from-class="opacity-100"
          leave-to-class="opacity-0"
        >
          <slot name="options">
            <Teleport v-if="open" to="body">
              <div
                class="z-backdrop fixed inset-0 h-full w-full bg-transparent"
                @click="handleClose"
              >
                <ListboxOptions
                  class="z-tooltip ring-border absolute mt-1 max-h-60 w-full overflow-auto rounded-md bg-white py-1 shadow-lg ring-1 first-letter:capitalize focus:outline-none"
                  :style="getPanelStyling()"
                >
                  <ListboxOption
                    v-for="option in options"
                    :key="option[keyField]"
                    v-slot="{ active, selected }"
                    :value="returnObjectValue ? option : option[keyField]"
                    as="template"
                    @click="handleItemClick"
                  >
                    <li
                      :class="[
                        active ? 'bg-primary text-white' : 'text-information',
                        'relative cursor-pointer select-none py-2 pl-3 pr-9 text-sm transition',
                      ]"
                    >
                      <span class="block truncate font-normal">
                        <slot name="item-label" v-bind="{ value: option }">
                          {{ getTranslatedProperty(option, labelField) }}
                        </slot>
                      </span>
                      <span
                        v-if="selected"
                        :class="[
                          active ? 'text-white' : 'text-primary',
                          'absolute inset-y-0 right-0 flex items-center pr-4',
                        ]"
                      >
                        <span class="i-sw-regular:checkmark-xs text-[1.125rem]" />
                      </span>
                    </li>
                  </ListboxOption>
                </ListboxOptions>
              </div>
            </Teleport>
          </slot>
        </Transition>
      </div>
    </Listbox>
    <slot name="errors"><SwError class="text-danger" :errors="props.errors" /></slot>
  </div>
</template>
